/**
 * DevExtreme (ui/drawer/ui.drawer.rendering.strategy.overlap.js)
 * Version: 18.2.0 (build 18225)
 * Build date: Mon Aug 13 2018
 *
 * Copyright (c) 2012 - 2018 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _uiDrawerRendering = require("./ui.drawer.rendering.strategy");
var _uiDrawerRendering2 = _interopRequireDefault(_uiDrawerRendering);
var _renderer = require("../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _translator = require("../../animation/translator");
var _translator2 = _interopRequireDefault(_translator);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}
var OverlapStrategy = _uiDrawerRendering2.default.inherit({
    renderPosition: function(offset, animate) {
        var _this = this;
        this.callBase(offset, animate);
        var direction = this._drawer.option("position");
        var menuPosition = this._getMenuOffset(offset);
        (0, _renderer2.default)(this._drawer.viewContent()).css("paddingLeft", this._drawer.option("minWidth") * this._drawer._getPositionCorrection());
        if ("slide" === this._drawer.option("revealMode")) {
            if (animate) {
                var animationConfig = {
                    $element: (0, _renderer2.default)(this._drawer._$menu),
                    position: menuPosition,
                    duration: this._drawer.option("animationDuration"),
                    direction: direction,
                    complete: function() {
                        _this._contentAnimation.resolve();
                        _this._menuAnimation.resolve()
                    }
                };
                _uiDrawerRendering.animation.moveTo(animationConfig)
            } else {
                _translator2.default.move((0, _renderer2.default)(this._drawer._$menu), {
                    left: menuPosition * this._drawer._getPositionCorrection()
                })
            }
        }
        if ("expand" === this._drawer.option("revealMode")) {
            var width = this._getMenuWidth(offset);
            if (animate) {
                _uiDrawerRendering.animation.width((0, _renderer2.default)(this._drawer._$menu), width, this._drawer.option("animationDuration"), function() {
                    _this._contentAnimation.resolve();
                    _this._menuAnimation.resolve()
                })
            } else {
                (0, _renderer2.default)(this._drawer._$menu).css("width", width)
            }
        }
    }
});
module.exports = OverlapStrategy;
