/**
 * DevExtreme (ui/drawer/ui.drawer.rendering.strategy.push.js)
 * Version: 18.2.0 (build 18225)
 * Build date: Mon Aug 13 2018
 *
 * Copyright (c) 2012 - 2018 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _uiDrawerRendering = require("./ui.drawer.rendering.strategy");
var _uiDrawerRendering2 = _interopRequireDefault(_uiDrawerRendering);
var _renderer = require("../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _translator = require("../../animation/translator");
var _translator2 = _interopRequireDefault(_translator);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}
var PushStrategy = _uiDrawerRendering2.default.inherit({
    renderPosition: function(offset, animate) {
        var _this = this;
        this.callBase(offset, animate);
        (0, _renderer2.default)(this._drawer.viewContent()).css("paddingLeft", 0);
        var contentPosition = this._getMenuWidth(offset) * this._drawer._getPositionCorrection();
        if (animate) {
            var animationConfig = {
                $element: (0, _renderer2.default)(this._drawer.viewContent()),
                position: contentPosition,
                duration: this._drawer.option("animationDuration"),
                complete: function() {
                    _this._contentAnimation.resolve();
                    _this._menuAnimation.resolve()
                }
            };
            _uiDrawerRendering.animation.moveTo(animationConfig)
        } else {
            _translator2.default.move((0, _renderer2.default)(this._drawer.viewContent()), {
                left: contentPosition
            })
        }
    }
});
module.exports = PushStrategy;
