/**
 * DevExtreme (ui/drawer/ui.drawer.rendering.strategy.shrink.js)
 * Version: 18.2.0 (build 18225)
 * Build date: Mon Aug 13 2018
 *
 * Copyright (c) 2012 - 2018 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _uiDrawerRendering = require("./ui.drawer.rendering.strategy");
var _uiDrawerRendering2 = _interopRequireDefault(_uiDrawerRendering);
var _renderer = require("../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _translator = require("../../animation/translator");
var _translator2 = _interopRequireDefault(_translator);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}
var ShrinkStrategy = _uiDrawerRendering2.default.inherit({
    renderPosition: function(offset, animate) {
        var _this = this;
        this.callBase(offset, animate);
        var width = this._getMenuWidth(offset),
            direction = this._drawer.option("position");
        _translator2.default.move((0, _renderer2.default)(this._drawer.viewContent()), {
            left: 0
        });
        this._animateContent(animate, offset, width, direction);
        if ("slide" === this._drawer.option("revealMode")) {
            var menuPos = this._getMenuOffset(offset);
            if (animate) {
                var animationConfig = {
                    $element: (0, _renderer2.default)(this._drawer._$menu),
                    position: menuPos,
                    duration: this._drawer.option("animationDuration"),
                    direction: direction,
                    complete: function() {
                        _this._menuAnimation.resolve()
                    }
                };
                _uiDrawerRendering.animation.moveTo(animationConfig)
            } else {
                _translator2.default.move((0, _renderer2.default)(this._drawer._$menu), {
                    left: menuPos * this._drawer._getPositionCorrection()
                })
            }
        }
        if ("expand" === this._drawer.option("revealMode")) {
            if (animate) {
                _uiDrawerRendering.animation.width((0, _renderer2.default)(this._drawer._$menu), width, this._drawer.option("animationDuration"), function() {
                    _this._menuAnimation.resolve()
                })
            } else {
                (0, _renderer2.default)(this._drawer._$menu).css("width", width)
            }
        }
    },
    _animateContent: function(animate, offset, width, direction) {
        var _this2 = this;
        _translator2.default.move((0, _renderer2.default)(this._drawer.viewContent()), {
            left: 0
        });
        if (animate) {
            var animationConfig = {
                $element: (0, _renderer2.default)(this._drawer.viewContent()),
                padding: width,
                direction: direction,
                duration: this._drawer.option("animationDuration"),
                complete: function() {
                    _this2._contentAnimation.resolve()
                }
            };
            _uiDrawerRendering.animation.padding(animationConfig)
        } else {
            if ("left" === direction) {
                (0, _renderer2.default)(this._drawer.viewContent()).css("paddingLeft", width)
            } else {
                (0, _renderer2.default)(this._drawer.viewContent()).css("paddingRight", width)
            }
        }
    }
});
module.exports = ShrinkStrategy;
